package MyApp;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;

use MyApp::View;
use MyApp::Response;

use UNIVERSAL::require;

__PACKAGE__->mk_accessors(qw/request path/);

sub dispatch {
    my $self = shift;
    my $con = $self->controller;

    $con->req  = $self->request;
    $con->res  = MyApp::Response->new;
    $con->view = MyApp::View->new({ path_segments => [ $self->path_segments ] });

    $con->handle_request;
    return $con->res;
}

sub controller {
    my $self = shift;
    my $handler = join '::', 'MyApp', 'Controller', map { ucfirst } $self->path_segments;
    $handler->require or die $@;
    return $handler->new;
}

sub path_segments {
    my $self = shift;
    $self->path ||= '/';

    my @path_segments = split '/', $self->path;
    shift @path_segments;
    push @path_segments, 'index' if not @path_segments;

    return @path_segments;
}

1;
