package MyApp::View;
use strict;
use warnings;
use base qw/Class::Accessor::Lvalue::Fast/;

use File::Spec;
use Template;

__PACKAGE__->mk_accessors(qw/path_segments vars/);

sub vars {
    my $self = shift;
    $self->{vars} ||= {};

    if (@_) {
        my %args = @_;
        while (my ($key, $value) = each %args) {
            $self->{vars}->{$key} = $value;
        }
    } else {
        return $self->{vars};
    }
}

sub template_file {
    my $self = shift;
    my $file = File::Spec->catfile( 'templates', @{$self->path_segments} );
    $file .= '.html';

    return $file;
}

sub render {
    my $self = shift;
    my $template = Template->new;
    $template->process($self->template_file, $self->vars, \my $out)
        or die $template->error;

    return $out;
}

1;
