#!/usr/local/bin/perl
use strict;
use warnings;
use encoding 'utf-8';

use CGI qw/:standard/;
use Template;

use FindBin::libs;
use MyApp::YouTube;

my $q = CGI->new;

if ($q->param('json') and $q->param('q')) {
    print
        $q->header( -type => 'application/json', -charset => 'utf-8' ),
        MyApp::YouTube->search($q->param('q'))->to_json;
} else {
    print $q->header( -type => 'text/html', -charset => 'utf-8' );

    my $file = $q->param('q')
        ? 'templates/result02.html'
        : 'templates/index.html';

    my $vars = $q->param('q')
        ? { result => MyApp::YouTube->search( $q->param('q') ), q => $q->param('q') }
        : {};

    my $template = Template->new;
    $template->process($file, $vars, \my $out) or die $template->error;

    print $out;
}
